Use Gnulib's `sys_stat' module; update Gnulib.
[bpt/guile.git] / maint.mk
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
4
5 ## Copyright (C) 2001-2009 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <http://www.gnu.org/licenses/>.
19
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
23
24 # Override this in cfg.mk if you use a non-standard build-aux directory.
25 build_aux ?= $(srcdir)/build-aux
26
27 # Do not save the original name or timestamp in the .tar.gz file.
28 # Use --rsyncable if available.
29 gzip_rsyncable := \
30 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null && echo --rsyncable)
31 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
32
33 # cfg.mk must define the gpg_key_ID used by this package.
34 GIT = git
35 VC = $(GIT)
36 VC-tag = git tag -s -m '$(VERSION)' -u '$(gpg_key_ID)'
37
38 VC_LIST = $(build_aux)/vc-list-files -C $(srcdir)
39
40 VC_LIST_EXCEPT = \
41 $(VC_LIST) | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
42 else grep -Ev "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi
43
44 ifeq ($(origin prev_version_file), undefined)
45 prev_version_file = $(srcdir)/.prev-version
46 endif
47
48 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
49 VERSION_REGEXP = $(subst .,\.,$(VERSION))
50 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
51
52 ifeq ($(VC),$(GIT))
53 this-vc-tag = v$(VERSION)
54 this-vc-tag-regexp = v$(VERSION_REGEXP)
55 else
56 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
57 tag-this-version = $(subst .,_,$(VERSION))
58 this-vc-tag = $(tag-package)-$(tag-this-version)
59 this-vc-tag-regexp = $(this-vc-tag)
60 endif
61 my_distdir = $(PACKAGE)-$(VERSION)
62
63 # Old releases are stored here.
64 release_archive_dir ?= ../release
65
66 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
67 # Use alpha.gnu.org for alpha and beta releases.
68 # Use ftp.gnu.org for stable releases.
69 gnu_ftp_host-alpha = alpha.gnu.org
70 gnu_ftp_host-beta = alpha.gnu.org
71 gnu_ftp_host-stable = ftp.gnu.org
72 gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
73
74 ifeq ($(gnu_rel_host),ftp.gnu.org)
75 url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
76 else
77 url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
78 endif
79
80 # Override this in cfg.mk if you are using a different format in your
81 # NEWS file.
82 today = $(shell date +%Y-%m-%d)
83 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
84
85 # Prevent programs like 'sort' from considering distinct strings to be equal.
86 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
87 export LC_ALL = C
88
89 ## --------------- ##
90 ## Sanity checks. ##
91 ## --------------- ##
92
93 _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
94
95 # Collect the names of rules starting with `sc_'.
96 syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
97 $(srcdir)/$(ME) $(_cfg_mk)))
98 .PHONY: $(syntax-check-rules)
99
100 local-checks-available = \
101 $(syntax-check-rules)
102 .PHONY: $(local-checks-available)
103
104 # Arrange to print the name of each syntax-checking rule just before running it.
105 $(syntax-check-rules): %: %.m
106 $(patsubst %, %.m, $(syntax-check-rules)):
107 @echo $(patsubst sc_%.m, %, $@)
108
109 local-check := $(filter-out $(local-checks-to-skip), $(local-checks-available))
110
111 syntax-check: $(local-check)
112 # @grep -nE '# *include <(limits|std(def|arg|bool))\.h>' \
113 # $$(find -type f -name '*.[chly]') && \
114 # { echo '$(ME): found conditional include' 1>&2; \
115 # exit 1; } || :
116
117 # grep -nE '^# *include <(string|stdlib)\.h>' \
118 # $(srcdir)/{lib,src}/*.[chy] && \
119 # { echo '$(ME): FIXME' 1>&2; \
120 # exit 1; } || :
121 # FIXME: don't allow `#include .strings\.h' anywhere
122
123 # By default, _prohibit_regexp does not ignore case.
124 export ignore_case =
125 _ignore_case = $$(test -n "$$ignore_case" && echo -i || :)
126
127 # There are many rules below that prohibit constructs in this package.
128 # If the offending construct can be matched with a grep-E-style regexp,
129 # use this macro. The shell variables "re" and "msg" must be defined.
130 define _prohibit_regexp
131 dummy=; : so we do not need a semicolon before each use; \
132 test "x$$re" != x || { echo '$(ME): re not defined' 1>&2; exit 1; }; \
133 test "x$$msg" != x || { echo '$(ME): msg not defined' 1>&2; exit 1; };\
134 grep $(_ignore_case) -nE "$$re" $$($(VC_LIST_EXCEPT)) && \
135 { echo '$(ME): '"$$msg" 1>&2; exit 1; } || :
136 endef
137
138 sc_avoid_if_before_free:
139 @$(build_aux)/useless-if-before-free \
140 $(useless_free_options) \
141 $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
142 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
143 exit 1; } || :
144
145 sc_cast_of_argument_to_free:
146 @re='\<free *\( *\(' msg='don'\''t cast free argument' \
147 $(_prohibit_regexp)
148
149 sc_cast_of_x_alloc_return_value:
150 @re='\*\) *x(m|c|re)alloc\>' \
151 msg='don'\''t cast x*alloc return value' \
152 $(_prohibit_regexp)
153
154 sc_cast_of_alloca_return_value:
155 @re='\*\) *alloca\>' msg='don'\''t cast alloca return value' \
156 $(_prohibit_regexp)
157
158 sc_space_tab:
159 @re='[ ] ' msg='found SPACE-TAB sequence; remove the SPACE' \
160 $(_prohibit_regexp)
161
162 # Don't use *scanf or the old ato* functions in `real' code.
163 # They provide no error checking mechanism.
164 # Instead, use strto* functions.
165 sc_prohibit_atoi_atof:
166 @re='\<([fs]?scanf|ato([filq]|ll)) *\(' \
167 msg='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
168 $(_prohibit_regexp)
169
170 # Use STREQ rather than comparing strcmp == 0, or != 0.
171 sc_prohibit_strcmp:
172 @grep -nE '! *str''cmp *\(|\<str''cmp *\([^)]+\) *==' \
173 $$($(VC_LIST_EXCEPT)) \
174 | grep -vE ':# *define STREQ\(' && \
175 { echo '$(ME): use STREQ in place of the above uses of str''cmp' \
176 1>&2; exit 1; } || :
177
178 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
179 # Convert all uses automatically, via these two commands:
180 # git grep -l '\<exit *(1)' \
181 # | grep -vEf .x-sc_prohibit_magic_number_exit \
182 # | xargs --no-run-if-empty \
183 # perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
184 # git grep -l '\<exit *(0)' \
185 # | grep -vEf .x-sc_prohibit_magic_number_exit \
186 # | xargs --no-run-if-empty \
187 # perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
188 sc_prohibit_magic_number_exit:
189 @re='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
190 msg='use EXIT_* values rather than magic number' \
191 $(_prohibit_regexp)
192
193 # Using EXIT_SUCCESS as the first argument to error is misleading,
194 # since when that parameter is 0, error does not exit. Use `0' instead.
195 sc_error_exit_success:
196 @grep -nE 'error \(EXIT_SUCCESS,' \
197 $$($(VC_LIST_EXCEPT) | grep -E '\.[chly]$$') && \
198 { echo '$(ME): found error (EXIT_SUCCESS' 1>&2; exit 1; } || :
199
200 # `FATAL:' should be fully upper-cased in error messages
201 # `WARNING:' should be fully upper-cased, or fully lower-cased
202 sc_error_message_warn_fatal:
203 @grep -nEA2 '[^rp]error \(' $$($(VC_LIST_EXCEPT)) \
204 | grep -E '"Warning|"Fatal|"fatal' && \
205 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
206 exit 1; } || :
207
208 # Error messages should not start with a capital letter
209 sc_error_message_uppercase:
210 @grep -nEA2 '[^rp]error \(' $$($(VC_LIST_EXCEPT)) \
211 | grep -E '"[A-Z]' \
212 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
213 { echo '$(ME): found capitalized error message' 1>&2; \
214 exit 1; } || :
215
216 # Error messages should not end with a period
217 sc_error_message_period:
218 @grep -nEA2 '[^rp]error \(' $$($(VC_LIST_EXCEPT)) \
219 | grep -E '[^."]\."' && \
220 { echo '$(ME): found error message ending in period' 1>&2; \
221 exit 1; } || :
222
223 sc_file_system:
224 @re=file''system ignore_case=1 \
225 msg='found use of "file''system"; spell it "file system"' \
226 $(_prohibit_regexp)
227
228 # Don't use cpp tests of this symbol. All code assumes config.h is included.
229 sc_prohibit_have_config_h:
230 @grep -n '^# *if.*HAVE''_CONFIG_H' $$($(VC_LIST_EXCEPT)) && \
231 { echo '$(ME): found use of HAVE''_CONFIG_H; remove' \
232 1>&2; exit 1; } || :
233
234 # Nearly all .c files must include <config.h>. However, we also permit this
235 # via inclusion of a package-specific header, if cfg.mk specified one.
236 # config_h_header must be suitable for grep -E.
237 config_h_header ?= <config\.h>
238 sc_require_config_h:
239 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
240 grep -EL '^# *include $(config_h_header)' \
241 $$($(VC_LIST_EXCEPT) | grep '\.c$$') \
242 | grep . && \
243 { echo '$(ME): the above files do not include <config.h>' \
244 1>&2; exit 1; } || :; \
245 else :; \
246 fi
247
248 # You must include <config.h> before including any other header file.
249 # This can possibly be via a package-specific header, if given by cfg.mk.
250 sc_require_config_h_first:
251 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
252 fail=0; \
253 for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
254 grep '^# *include\>' $$i | sed 1q \
255 | grep -E '^# *include $(config_h_header)' > /dev/null \
256 || { echo $$i; fail=1; }; \
257 done; \
258 test $$fail = 1 && \
259 { echo '$(ME): the above files include some other header' \
260 'before <config.h>' 1>&2; exit 1; } || :; \
261 else :; \
262 fi
263
264 sc_prohibit_HAVE_MBRTOWC:
265 @re='\bHAVE_MBRTOWC\b' msg="do not use $$re; it is always defined" \
266 $(_prohibit_regexp)
267
268 # To use this "command" macro, you must first define two shell variables:
269 # h: the header, enclosed in <> or ""
270 # re: a regular expression that matches IFF something provided by $h is used.
271 define _header_without_use
272 dummy=; : so we do not need a semicolon before each use; \
273 h_esc=`echo "$$h"|sed 's/\./\\\\./g'`; \
274 if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
275 files=$$(grep -l '^# *include '"$$h_esc" \
276 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
277 grep -LE "$$re" $$files | grep . && \
278 { echo "$(ME): the above files include $$h but don't use it" \
279 1>&2; exit 1; } || :; \
280 else :; \
281 fi
282 endef
283
284 # Prohibit the inclusion of assert.h without an actual use of assert.
285 sc_prohibit_assert_without_use:
286 @h='<assert.h>' re='\<assert *\(' $(_header_without_use)
287
288 # Prohibit the inclusion of close-stream.h without an actual use.
289 sc_prohibit_close_stream_without_use:
290 @h='"close-stream.h"' re='\<close_stream *\(' $(_header_without_use)
291
292 # Prohibit the inclusion of getopt.h without an actual use.
293 sc_prohibit_getopt_without_use:
294 @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_header_without_use)
295
296 # Don't include quotearg.h unless you use one of its functions.
297 sc_prohibit_quotearg_without_use:
298 @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_header_without_use)
299
300 # Don't include quote.h unless you use one of its functions.
301 sc_prohibit_quote_without_use:
302 @h='"quote.h"' re='\<quote(_n)? *\(' $(_header_without_use)
303
304 # Don't include this header unless you use one of its functions.
305 sc_prohibit_long_options_without_use:
306 @h='"long-options.h"' re='\<parse_long_options *\(' \
307 $(_header_without_use)
308
309 # Don't include this header unless you use one of its functions.
310 sc_prohibit_inttostr_without_use:
311 @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \
312 $(_header_without_use)
313
314 # Don't include this header unless you use one of its functions.
315 sc_prohibit_error_without_use:
316 @h='"error.h"' \
317 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
318 $(_header_without_use)
319
320 # Don't include xalloc.h unless you use one of its functions.
321 # Consider these symbols:
322 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
323 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) \(/ and print $1' lib/xalloc.h
324 # Divide into two sets on case, and filter each through this:
325 # | sort | perl -MRegexp::Assemble -le \
326 # 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
327 # Note this was produced by the above:
328 # _xa1 = x(alloc_(oversized|die)|([cz]|2?re)alloc|m(alloc|emdup)|strdup)
329 # But we can do better:
330 _xa1 = x(alloc_(oversized|die)|([cmz]|2?re)alloc|(mem|str)dup)
331 _xa2 = X([CZ]|N?M)ALLOC
332 sc_prohibit_xalloc_without_use:
333 @h='"xalloc.h"' \
334 re='\<($(_xa1)|$(_xa2)) *\('\
335 $(_header_without_use)
336
337 sc_prohibit_safe_read_without_use:
338 @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
339 $(_header_without_use)
340
341 sc_prohibit_argmatch_without_use:
342 @h='"argmatch.h"' \
343 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
344 $(_header_without_use)
345
346 sc_prohibit_canonicalize_without_use:
347 @h='"canonicalize.h"' \
348 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
349 $(_header_without_use)
350
351 sc_prohibit_root_dev_ino_without_use:
352 @h='"root-dev-ino.h"' \
353 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
354 $(_header_without_use)
355
356 sc_prohibit_openat_without_use:
357 @h='"openat.h"' \
358 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
359 $(_header_without_use)
360
361 # Prohibit the inclusion of c-ctype.h without an actual use.
362 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
363 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
364 sc_prohibit_c_ctype_without_use:
365 @h='[<"]c-ctype.h[">]' re='\<c_($(ctype_re)) *\(' $(_header_without_use)
366
367 _empty =
368 _sp = $(_empty) $(_empty)
369 # The following list was generated by running:
370 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
371 # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
372 _sig_functions = \
373 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
374 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
375 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
376 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
377 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
378 # The following were extracted from "man signal.h" manually.
379 _sig_types_and_consts = \
380 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
381 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
382 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
383 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
384 sigstack sigval stack_t ucontext_t
385 # generated via this:
386 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
387 _sig_names = \
388 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
389 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
390 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
391 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
392 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
393 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
394 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
395 SIGXCPU SIGXFSZ
396 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
397
398 # Prohibit the inclusion of signal.h without an actual use.
399 sc_prohibit_signal_without_use:
400 @h='<signal.h>' \
401 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
402 $(_header_without_use)
403
404 sc_obsolete_symbols:
405 @re='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
406 msg='do not use HAVE''_FCNTL_H or O'_NDELAY \
407 $(_prohibit_regexp)
408
409 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
410
411 # Each nonempty ChangeLog line must start with a year number, or a TAB.
412 sc_changelog:
413 @if $(VC_LIST_EXCEPT) | grep -l '^ChangeLog$$' >/dev/null; then \
414 grep -n '^[^12 ]' \
415 $$($(VC_LIST_EXCEPT) | grep '^ChangeLog$$') && \
416 { echo '$(ME): found unexpected prefix in a ChangeLog' 1>&2; \
417 exit 1; } || :; \
418 fi
419
420 # Ensure that each .c file containing a "main" function also
421 # calls set_program_name.
422 sc_program_name:
423 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
424 files=$$(grep -l '^main *(' $$($(VC_LIST_EXCEPT) | grep '\.c$$')); \
425 grep -LE 'set_program_name *\(m?argv\[0\]\);' $$files \
426 | grep . && \
427 { echo '$(ME): the above files do not call set_program_name' \
428 1>&2; exit 1; } || :; \
429 else :; \
430 fi
431
432 # Require that the final line of each test-lib.sh-using test be this one:
433 # Exit $fail
434 # Note: this test requires GNU grep's --label= option.
435 Exit_witness_file ?= tests/test-lib.sh
436 Exit_base := $(notdir $(Exit_witness_file))
437 sc_require_test_exit_idiom:
438 @if test -f $(srcdir)/$(Exit_witness_file); then \
439 die=0; \
440 for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
441 $$($(VC_LIST) tests)); do \
442 tail -n1 $$i | grep '^Exit .' > /dev/null \
443 && : || { die=1; echo $$i; } \
444 done; \
445 test $$die = 1 && \
446 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
447 echo 1>&2 'Exit something'; \
448 exit 1; } || :; \
449 fi
450
451 sc_the_the:
452 @re='\<the ''the\>' \
453 ignore_case=1 msg='found use of "the ''the";' \
454 $(_prohibit_regexp)
455
456 sc_trailing_blank:
457 @re='[ ]$$' \
458 msg='found trailing blank(s)' \
459 $(_prohibit_regexp)
460
461 # Match lines like the following, but where there is only one space
462 # between the options and the description:
463 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
464 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
465 sc_two_space_separator_in_usage:
466 @grep -nE '^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
467 $$($(VC_LIST_EXCEPT)) && \
468 { echo "$(ME): help2man requires at least two spaces between"; \
469 echo "$(ME): an option and its description"; \
470 1>&2; exit 1; } || :
471
472 # Look for diagnostics that aren't marked for translation.
473 # This won't find any for which error's format string is on a separate line.
474 sc_unmarked_diagnostics:
475 @grep -nE \
476 '\<error \([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT)) \
477 | grep -v '_''(' && \
478 { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
479 exit 1; } || :
480
481 # Avoid useless parentheses like those in this example:
482 # #if defined (SYMBOL) || defined (SYM2)
483 sc_useless_cpp_parens:
484 @grep -n '^# *if .*defined *(' $$($(VC_LIST_EXCEPT)) && \
485 { echo '$(ME): found useless parentheses in cpp directive' \
486 1>&2; exit 1; } || :
487
488 # Require the latest GPL.
489 sc_GPL_version:
490 @re='either ''version [^3]' msg='GPL vN, N!=3' \
491 $(_prohibit_regexp)
492
493 cvs_keywords = \
494 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
495
496 sc_prohibit_cvs_keyword:
497 @re='\$$($(cvs_keywords))\$$' \
498 msg='do not use CVS keyword expansion' \
499 $(_prohibit_regexp)
500
501 # Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
502 # This is a bit of a kludge, since it prevents use of the string
503 # even in comments, but for now it does the job with no false positives.
504 sc_prohibit_stat_st_blocks:
505 @re='[.>]st_blocks' msg='do not use st_blocks; use ST_NBLOCKS' \
506 $(_prohibit_regexp)
507
508 # Make sure we don't define any S_IS* macros in src/*.c files.
509 # They're already defined via gnulib's sys/stat.h replacement.
510 sc_prohibit_S_IS_definition:
511 @re='^ *# *define *S_IS' \
512 msg='do not define S_IS* macros; include <sys/stat.h>' \
513 $(_prohibit_regexp)
514
515 # Each program that uses proper_name_utf8 must link with
516 # one of the ICONV libraries.
517 sc_proper_name_utf8_requires_ICONV:
518 @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
519 if test "x$$progs" != x; then \
520 fail=0; \
521 for p in $$progs; do \
522 dir=$$(dirname "$$p"); \
523 base=$$(basename "$$p" .c); \
524 grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
525 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
526 done; \
527 test $$fail = 1 && \
528 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
529 exit 1; } || :; \
530 fi
531
532 # Warn about "c0nst struct Foo const foo[]",
533 # but not about "char const *const foo" or "#define const const".
534 sc_redundant_const:
535 @re='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
536 msg='redundant "const" in declarations' \
537 $(_prohibit_regexp)
538
539 sc_const_long_option:
540 @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT)) \
541 | grep -Ev 'const struct option|struct option const' && { \
542 echo 1>&2 '$(ME): add "const" to the above declarations'; \
543 exit 1; } || :
544
545 NEWS_hash = \
546 $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
547 $(srcdir)/NEWS \
548 | grep -v '^Copyright .*Free Software' \
549 | md5sum - \
550 | sed 's/ .*//')
551
552 # Ensure that we don't accidentally insert an entry into an old NEWS block.
553 sc_immutable_NEWS:
554 @if test -f $(srcdir)/NEWS; then \
555 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
556 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
557 fi
558
559 # Update the hash stored above. Do this after each release and
560 # for any corrections to old entries.
561 update-NEWS-hash: NEWS
562 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
563 $(srcdir)/cfg.mk
564
565 # Ensure that we use only the standard $(VAR) notation,
566 # not @...@ in Makefile.am, now that we can rely on automake
567 # to emit a definition for each substituted variable.
568 # We use perl rather than "grep -nE ..." to exempt a single
569 # use of an @...@-delimited variable name in src/Makefile.am.
570 sc_makefile_check:
571 @perl -ne '/\@[A-Z_0-9]+\@/ && !/^cu_install_program =/' \
572 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
573 $$($(VC_LIST_EXCEPT) | grep -E '(^|/)Makefile\.am$$') \
574 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
575
576 news-check: NEWS
577 if head $(srcdir)/NEWS | grep -E $(news-check-regexp) \
578 >/dev/null; then \
579 :; \
580 else \
581 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
582 exit 1; \
583 fi
584
585 sc_makefile_TAB_only_indentation:
586 @grep -nE '^ [ ]{8}' \
587 $$($(VC_LIST_EXCEPT) | grep -E 'akefile|\.mk$$') \
588 && { echo '$(ME): found TAB-8-space indentation' 1>&2; \
589 exit 1; } || :
590
591 sc_m4_quote_check:
592 @grep -nE '(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
593 $$($(VC_LIST_EXCEPT) | grep -E '(^configure\.ac|\.m4)$$') \
594 && { echo '$(ME): quote the first arg to AC_DEF*' 1>&2; \
595 exit 1; } || :
596
597 fix_po_file_diag = \
598 'you have changed the set of files with translatable diagnostics;\n\
599 apply the above patch\n'
600
601 # Verify that all source files using _() are listed in po/POTFILES.in.
602 po_file = po/POTFILES.in
603 sc_po_check:
604 @if test -f $(po_file); then \
605 grep -E -v '^(#|$$)' $(po_file) \
606 | grep -v '^src/false\.c$$' | sort > $@-1; \
607 files=; \
608 for file in $$($(VC_LIST_EXCEPT)) lib/*.[ch]; do \
609 test -r $$file || continue; \
610 case $$file in \
611 *.m4|*.mk) continue ;; \
612 *.?|*.??) ;; \
613 *) continue;; \
614 esac; \
615 case $$file in \
616 *.[ch]) \
617 base=`expr " $$file" : ' \(.*\)\..'`; \
618 { test -f $$base.l || test -f $$base.y; } && continue;; \
619 esac; \
620 files="$$files $$file"; \
621 done; \
622 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
623 | sort -u > $@-2; \
624 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
625 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
626 rm -f $@-1 $@-2; \
627 fi
628
629 # Sometimes it is useful to change the PATH environment variable
630 # in Makefiles. When doing so, it's better not to use the Unix-centric
631 # path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
632 msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
633 sc_makefile_path_separator_check:
634 @grep -nE 'PATH[=].*:' \
635 $$($(VC_LIST_EXCEPT) | grep -E 'akefile|\.mk$$') \
636 && { echo $(msg) 1>&2; exit 1; } || :
637
638 # Check that `make alpha' will not fail at the end of the process.
639 writable-files:
640 if test -d $(release_archive_dir); then :; else \
641 for file in $(distdir).tar.gz \
642 $(release_archive_dir)/$(distdir).tar.gz; do \
643 test -e $$file || continue; \
644 test -w $$file \
645 || { echo ERROR: $$file is not writable; fail=1; }; \
646 done; \
647 test "$$fail" && exit 1 || : ; \
648 fi
649
650 v_etc_file = lib/version-etc.c
651 sample-test = tests/sample-test
652 texi = doc/$(PACKAGE).texi
653 # Make sure that the copyright date in $(v_etc_file) is up to date.
654 # Do the same for the $(sample-test) and the main doc/.texi file.
655 sc_copyright_check:
656 @if test -f $(v_etc_file); then \
657 grep 'enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' $(v_etc_file) \
658 >/dev/null \
659 || { echo 'out of date copyright in $(v_etc_file); update it' 1>&2; \
660 exit 1; }; \
661 fi
662 @if test -f $(sample-test); then \
663 grep '# Copyright (C) '$$(date +%Y)' Free' $(sample-test) \
664 >/dev/null \
665 || { echo 'out of date copyright in $(sample-test); update it' 1>&2; \
666 exit 1; }; \
667 fi
668 @if test -f $(texi); then \
669 grep 'Copyright @copyright{} .*'$$(date +%Y)' Free' $(texi) \
670 >/dev/null \
671 || { echo 'out of date copyright in $(texi); update it' 1>&2; \
672 exit 1; }; \
673 fi
674
675 vc-diff-check:
676 (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
677 if test -s vc-diffs; then \
678 cat vc-diffs; \
679 echo "Some files are locally modified:" 1>&2; \
680 exit 1; \
681 else \
682 rm vc-diffs; \
683 fi
684
685 rel-files = $(DIST_ARCHIVES)
686
687 gnulib_dir ?= $(srcdir)/gnulib
688 gnulib-version = $$(cd $(gnulib_dir) && git describe)
689 bootstrap-tools ?= autoconf,automake,gnulib
690
691 announcement: NEWS ChangeLog $(rel-files)
692 @$(build_aux)/announce-gen \
693 --release-type=$(RELEASE_TYPE) \
694 --package=$(PACKAGE) \
695 --prev=$(PREV_VERSION) \
696 --curr=$(VERSION) \
697 --gpg-key-id=$(gpg_key_ID) \
698 --news=NEWS \
699 --bootstrap-tools=$(bootstrap-tools) \
700 --gnulib-version=$(gnulib-version) \
701 --no-print-checksums \
702 $(addprefix --url-dir=, $(url_dir_list))
703
704 ## ---------------- ##
705 ## Updating files. ##
706 ## ---------------- ##
707
708 ftp-gnu = ftp://ftp.gnu.org/gnu
709 www-gnu = http://www.gnu.org
710
711 emit_upload_commands:
712 @echo =====================================
713 @echo =====================================
714 @echo "$(build_aux)/gnupload $(GNUPLOADFLAGS) \\"
715 @echo " --to $(gnu_rel_host):$(PACKAGE) \\"
716 @echo " $(rel-files)"
717 @echo '# send the /tmp/announcement e-mail'
718 @echo =====================================
719 @echo =====================================
720
721 noteworthy = * Noteworthy changes in release ?.? (????-??-??) [?]
722 define emit-commit-log
723 printf '%s\n' 'post-release administrivia' '' \
724 '* NEWS: Add header line for next release.' \
725 '* .prev-version: Record previous version.' \
726 '* cfg.mk (old_NEWS_hash): Auto-update.'
727 endef
728
729 .PHONY: no-submodule-changes
730 no-submodule-changes:
731 if test -d $(srcdir)/.git; then \
732 diff=$$(cd $(srcdir) && git submodule -q foreach \
733 git diff-index --name-only HEAD) \
734 || exit 1; \
735 case $$diff in '') ;; \
736 *) echo '$(ME): submodule files are locally modified:'; \
737 echo "$$diff"; exit 1;; esac; \
738 else \
739 : ; \
740 fi
741
742 .PHONY: alpha beta stable
743 ALL_RECURSIVE_TARGETS += alpha beta stable
744 alpha beta stable: $(local-check) writable-files no-submodule-changes
745 test $@ = stable \
746 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
747 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
748 || :
749 $(MAKE) vc-diff-check
750 $(MAKE) news-check
751 $(MAKE) distcheck
752 $(MAKE) dist XZ_OPT=-9ev
753 $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
754 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
755
756 # Override this in cfg.mk if you follow different procedures.
757 release-prep-hook ?= release-prep
758
759 .PHONY: release-prep
760 release-prep:
761 case $$RELEASE_TYPE in alpha|beta|stable) ;; \
762 *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
763 $(MAKE) -s announcement > /tmp/announce-$(my_distdir)
764 if test -d $(release_archive_dir); then \
765 ln $(rel-files) $(release_archive_dir); \
766 chmod a-w $(rel-files); \
767 fi
768 echo $(VERSION) > $(prev_version_file)
769 $(MAKE) update-NEWS-hash
770 perl -pi -e '$$. == 3 and print "$(noteworthy)\n\n\n"' NEWS
771 $(emit-commit-log) > .ci-msg
772 $(VC) commit -F .ci-msg -a
773
774 .PHONY: web-manual
775 web-manual:
776 @test -z "$(manual_title)" \
777 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
778 @cd '$(srcdir)/doc'; \
779 $(SHELL) ../build-aux/gendocs.sh -o '$(abs_builddir)/doc/manual' \
780 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
781 "$(PACKAGE_NAME) - $(manual_title)"
782 @echo " *** Upload the doc/manual directory to web-cvs."
783
784 # Code Coverage
785
786 init-coverage:
787 $(MAKE) $(AM_MAKEFLAGS) clean
788 lcov --directory . --zerocounters
789
790 COVERAGE_CCOPTS ?= "-g --coverage"
791 COVERAGE_OUT ?= doc/coverage
792
793 build-coverage:
794 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
795 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
796 mkdir -p $(COVERAGE_OUT)
797 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
798 --capture
799
800 gen-coverage:
801 genhtml --output-directory $(COVERAGE_OUT) \
802 $(COVERAGE_OUT)/$(PACKAGE).info \
803 --highlight --frames --legend \
804 --title "$(PACKAGE_NAME)"
805
806 coverage: init-coverage build-coverage gen-coverage
807
808 # Update gettext files.
809 PACKAGE ?= $(shell basename $(PWD))
810 PO_DOMAIN ?= $(PACKAGE)
811 POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
812 PODIR ?= po
813 refresh-po:
814 rm -f $(PODIR)/*.po && \
815 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
816 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
817 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
818 echo 'en@quot' >> $(PODIR)/LINGUAS && \
819 ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
820
821 INDENT_SOURCES ?= $(C_SOURCES)
822 .PHONY: indent
823 indent:
824 indent $(INDENT_SOURCES)
825
826 # If you want to set UPDATE_COPYRIGHT_* environment variables,
827 # put the assignments in this variable.
828 update-copyright-env ?=
829
830 # Run this rule once per year (usually early in January)
831 # to update all FSF copyright year lists in your project.
832 # If you have an additional project-specific rule,
833 # add it in cfg.mk along with a line 'update-copyright: prereq'.
834 # By default, exclude all variants of COPYING; you can also
835 # add exemptions (such as ChangeLog..* for rotated change logs)
836 # in the file .x-update-copyright.
837 .PHONY: update-copyright
838 update-copyright:
839 grep -l -w Copyright \
840 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
841 | $(update-copyright-env) xargs $(build_aux)/$@